// 64-Switch (Windows GUI Double-Click Target)
// by Hendricks266

#include "64switch.h"

int main(void)
{
    FILE * pFile;
    static const unsigned int length = 255;
    wchar_t commandline[length];
    static const wchar_t *switch32 = L"32.txt";
    static const wchar_t *switch64 = L"64.txt";
    HINSTANCE output = 0;

    const wchar_t *PROCESSOR_ARCHITECTURE = wgetenv(L"PROCESSOR_ARCHITECTURE");
    const wchar_t *PROCESSOR_ARCHITEW6432 = wgetenv(L"PROCESSOR_ARCHITEW6432");
    if ((PROCESSOR_ARCHITECTURE && wcscasecmp(PROCESSOR_ARCHITECTURE,L"amd64") == 0) || (PROCESSOR_ARCHITEW6432 && wcscasecmp(PROCESSOR_ARCHITEW6432,L"amd64") == 0))
        pFile = wfopen (switch64, L"r");
    else if ((PROCESSOR_ARCHITECTURE && wcscasecmp(PROCESSOR_ARCHITECTURE,L"x86") == 0) && !PROCESSOR_ARCHITEW6432)
        pFile = wfopen (switch32, L"r");
    else
        pFile = wfopen (switch32, L"r");

    int pFileError = ferror(pFile);

    if (pFile == NULL || pFileError)
        fwprintf(stderr, L"Error opening file. (%i)\n", pFileError);
    else
    {
        fgetws (commandline, length, pFile);
        fclose (pFile);

        output = ShellExecuteW(NULL,NULL,commandline,GetCommandLineW(),NULL,SW_HIDE);
    }

	return (int)output;
}
